Bug 513636 - Review Request: php-layers-menu - Hierarchical PHP based DHTML menu system
Review Request: php-layers-menu - Hierarchical PHP based DHTML menu system
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: David Nalley
Fedora Extras Quality Assurance
:
Depends On:
Blocks: 493237 ipplan
  Show dependency treegraph
 
Reported: 2009-07-24 11:28 EDT by Andrew Colin Kissa
Modified: 2009-09-02 20:33 EDT (History)
5 users (show)

See Also:
Fixed In Version: 3.2.0-0.2.rc.fc10
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-09-02 16:56:02 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
david: fedora‑review+
tibbs: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Andrew Colin Kissa 2009-07-24 11:28:16 EDT
Spec URL: http://topdog-software.com/oss/SRPMS/fedora/php-layers-menu/php-layers-menu.spec
SRPM URL: http://topdog-software.com/oss/SRPMS/fedora/php-layers-menu/php-layers-menu-3.2.0-0.1.rc.fc11.src.rpm
Description:
This is a hierarchical menu system to prepare on the fly DHTML menus 
relying on the PHP scripting engine for the processing of data items.
It supports a wide range of browsers: Mozilla, Konqueror, Netscape, 
Safari, Opera, Internet Explorer; rather old browser versions are 
supported as well; accessibility is provided for text-only browsers.
Comment 1 David Nalley 2009-07-26 20:35:50 EDT
OK: rpmlint must be run on every package. The output should be posted in the
review.
[ke4qqq@nalleyt61 SPECS]$ rpmlint ./php-layers-menu.spec 
0 packages and 1 specfiles checked; 0 errors, 0 warnings.
[ke4qqq@nalleyt61 SPECS]$ rpmlint
../SRPMS/php-layers-menu-3.2.0-0.1.rc.fc11.src.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.
[ke4qqq@nalleyt61 SPECS]$ rpmlint
../RPMS/noarch/php-layers-menu-3.2.0-0.1.rc.fc11.noarch.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.

MUST: The package must be named according to the Package Naming Guidelines .

I have some questions about package name The name strikes me as phplayersmenu,
which should make the package name php-phplayersmenu, but I have asked for
clarification. 

OK: The spec file name must match the base package %{name}, in the format
%{name}.spec unless your package has an exemption. 
FIX: The package must meet the Packaging Guidelines .
See below - there are some file placement issues. 
OK: The package must be licensed with a Fedora approved license and meet the
Licensing Guidelines .
LGPLv2+ 
FIX: The License field in the package spec file must match the actual license.
you've listed LGPLv2 and based on notices it appears to be LGPLv2+
OK: If (and only if) the source package includes the text of the license(s) in
its own file, then that file, containing the text of the license(s) for the
package must be included in %doc
OK: The spec file must be written in American English.
OK: The spec file for the package MUST be legible. 
OK: The sources used to build the package must match the upstream source, as
provided in the spec URL. Reviewers should use md5sum for this task. If no
upstream URL can be specified for this package, please see the Source URL
Guidelines 
[ke4qqq@nalleyt61 SOURCES]$ sha1sum ./phplayersmenu-3.2.0-rc.tar.gz*
7b084da1e20ab2faa9da17b6a088b81d6eb0523b  ./phplayersmenu-3.2.0-rc.tar.gz
7b084da1e20ab2faa9da17b6a088b81d6eb0523b  ./phplayersmenu-3.2.0-rc.tar.gz.1


OK: The package MUST successfully compile and build into binary rpms on at
least one primary architecture. 
NA: If the package does not successfully compile, build or work on an
architecture, then those architectures should be listed in the spec in
ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in
bugzilla, describing the reason that the package does not compile/build/work on
that architecture. The bug number MUST be placed in a comment, next to the
corresponding ExcludeArch line. 
OK: All build dependencies must be listed in BuildRequires, except for any that
are listed in the exceptions section of the Packaging Guidelines ; inclusion of
those as BuildRequires is optional. Apply common sense.
NA: The spec file MUST handle locales properly. This is done by using the
%find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
NA: Every binary RPM package (or subpackage) which stores shared library files
(not just symlinks) in any of the dynamic linker's default paths, must call
ldconfig in %post and %postun. 
NA: If the package is designed to be relocatable, the packager must state this
fact in the request for review, along with the rationalization for relocation
of that specific package. Without this, use of Prefix: /usr is considered a
blocker. 
OK: A package must own all directories that it creates. If it does not create a
directory that it uses, then it should require a package which does create that
directory. 
OK: A Fedora package must not list a file more than once in the spec file's
%files listings. 
OK: Permissions on files must be set properly. Executables should be set with
executable permissions, for example. Every %files section must include a
%defattr(...) line. 
OK: Each package must have a %clean section, which contains rm -rf %{buildroot}
(or $RPM_BUILD_ROOT). 
OK: Each package must consistently use macros. 
OK: The package must contain code, or permissable content. 
NA: Large documentation files must go in a -doc subpackage. (The definition of
large is left up to the packager's best judgement, but is not restricted to
size. Large can refer to either size or quantity). 
OK: If a package includes something as %doc, it must not affect the runtime of
the application. To summarize: If it is in %doc, the program must run properly
if it is not present. 
NA: Header files must be in a -devel package. 
NA: Static libraries must be in a -static package. 
NA: Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig' (for
directory ownership and usability). 
NA: If a package contains library files with a suffix (e.g. libfoo.so.1.1),
then library files that end in .so (without suffix) must go in a -devel
package. 
NA: In the vast majority of cases, devel packages must require the base package
using a fully versioned dependency: Requires: %{name} = %{version}-%{release} 
NA: Packages must NOT contain any .la libtool archives, these must be removed
in the spec if they are built.
NA: Packages containing GUI applications must include a %{name}.desktop file,
and that file must be properly installed with desktop-file-install in the
%install section. If you feel that your packaged GUI application does not need
a .desktop file, you must put a comment in the spec file with your explanation. 
OK: Packages must not own files or directories already owned by other packages.
The rule of thumb here is that the first package to be installed should own the
files or directories that other packages may rely upon. This means, for
example, that no package in Fedora should ever share ownership with any of the
files or directories owned by the filesystem or man package. If you feel that
you have a good reason to own a file or directory that another package owns,
then please present that at package review time. 
OK: At the beginning of %install, each package MUST run rm -rf %{buildroot} (or
$RPM_BUILD_ROOT). 
OK: All filenames in rpm packages must be valid UTF-8. 



You are pushing stuff to %{_datadir}/%{name}
Take a look at: 
https://fedoraproject.org/wiki/Packaging:PHP#File_Placementhttps://fedoraproject.org/wiki/Packaging:PHP#File_Placement

Also it might be helpful to read some of the recent mailing list comments about
class file placement (which I think were on -devel) The gist of those
conversations is essentially that people don't want class files dumped in
%{_datadir}/php/ but rather %{_datadir}/php/%{name}/


Also  - on the bundling issue - it appears that phplayersmenu bundles
http://pear.php.net/package/HTML_Template_PHPLIB/ 

I'll add this to the zikula groups todo list - so perhaps that can be taken
care of by someone else. (or if not, I'll take care of it, as I have a package
that I just learned bundles phplayersmenu and thus the pear package too)
Comment 2 David Nalley 2009-07-27 02:18:38 EDT
(In reply to comment #1)
> 
> MUST: The package must be named according to the Package Naming Guidelines .
> 
> I have some questions about package name The name strikes me as phplayersmenu,
> which should make the package name php-phplayersmenu, but I have asked for
> clarification. 

Based on the feedback I received, this name appears acceptable.
Comment 3 Andrew Colin Kissa 2009-07-27 04:34:51 EDT
Hi David,

I have made the changes requested but i think it is better that i package the pear package as well (i can find the time) since that will speed up everything and remove the hold on this chain of packages.
Comment 4 Andrew Colin Kissa 2009-07-27 06:06:48 EDT
I have submitted a review request for HTML_Template_PHPLIB https://bugzilla.redhat.com/show_bug.cgi?id=513954
Comment 5 Andrew Colin Kissa 2009-07-27 13:10:32 EDT
FIXED

* Name - as stated the name is acceptable

* Install directory - corrected to %{_datadir}/php/%{name}/

* License - Updated to correct one LGPLv2+

* Bundled libraries - Unbundled HTML_Template_PHPLIB 

Updated spec and srpm
http://topdog-software.com/oss/SRPMS/fedora/php-layers-menu/php-layers-menu.spec
http://topdog-software.com/oss/SRPMS/fedora/php-layers-menu/php-layers-menu-3.2.0-0.2.rc.fc11.src.rpm
Comment 6 David Nalley 2009-07-27 22:41:07 EDT
I think requires should be php-pear-HTML_Template_PHPLIB. I assume you can fix this before it hits CVS. Of course pushing to stable should probably wait on the dependency. 

So I see the readme.fedora and the find/sed statement for fixing the demo stuff. I wonder if it would be easier to just symlink the 'system' PHPLIB.php into it's current location. No requirement there, just food for thought. (despite the fact that bundling libraries is forbidden by packaging guidelines, there is no guidance that I am aware of on how to handle the library unbundling.) Queries to -devel have provided a mixed response of essentially 'patching' the source, and symlinking, so I don't know that there is a wrong answer here. 

APPROVED


BTW, thanks for your work on this, it helps takes care of a bundling issue in one of my packages I wasn't aware of until I started the review.
Comment 7 Andrew Colin Kissa 2009-07-28 02:56:10 EDT
Thanks for the review David, pear packages seem to use the convention php-pear(%pear_name), changing this to the actual rpm package name causes an rpmlint error explicit-lib-dependency.

I think patching is a better solution for unbundling, as symlinking leads to an rpmlint error dangling symlink.

Thanks again for the review.

New Package CVS Request
=======================
Package Name: php-layers-menu
Short Description: Hierarchical PHP based DHTML menu system
Owners: topdog
Branches: F-10 F-11 EL-5
InitialCC: david
Comment 8 Jason Tibbitts 2009-07-28 20:56:18 EDT
CVS done.
Comment 9 Gary T. Giesen 2009-08-12 19:33:19 EDT
I believe the SRPM will have to be rebuilt with:

%_source_filedigest_algorithm md5
%_binary_filedigest_algorithm md5

in ~/.rpmmacros in order for this to build properly for EL-5
Comment 10 Susi Lehtola 2009-08-13 01:38:14 EDT
(In reply to comment #9)
> I believe the SRPM will have to be rebuilt with:
> 
> %_source_filedigest_algorithm md5
> %_binary_filedigest_algorithm md5
> 
> in ~/.rpmmacros in order for this to build properly for EL-5  

No, that's just for local builds in mock. Koji checks out the newest spec & sources from CVS and rebuilds the SRPM every time a package is built.
Comment 11 Fedora Update System 2009-08-17 15:22:20 EDT
php-layers-menu-3.2.0-0.2.rc.fc10 has been submitted as an update for Fedora 10.
http://admin.fedoraproject.org/updates/php-layers-menu-3.2.0-0.2.rc.fc10
Comment 12 Fedora Update System 2009-08-17 15:22:26 EDT
php-layers-menu-3.2.0-0.2.rc.el5 has been submitted as an update for Fedora EPEL 5.
http://admin.fedoraproject.org/updates/php-layers-menu-3.2.0-0.2.rc.el5
Comment 13 Fedora Update System 2009-08-17 15:22:31 EDT
php-layers-menu-3.2.0-0.2.rc.fc11 has been submitted as an update for Fedora 11.
http://admin.fedoraproject.org/updates/php-layers-menu-3.2.0-0.2.rc.fc11
Comment 14 Fedora Update System 2009-08-17 20:27:10 EDT
php-layers-menu-3.2.0-0.2.rc.el5 has been pushed to the Fedora EPEL 5 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update php-layers-menu'.  You can provide feedback for this update here: http://admin.fedoraproject.org/updates/EL-5/FEDORA-EPEL-2009-0307
Comment 15 Fedora Update System 2009-08-18 17:12:50 EDT
php-layers-menu-3.2.0-0.2.rc.fc11 has been pushed to the Fedora 11 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update php-layers-menu'.  You can provide feedback for this update here: http://admin.fedoraproject.org/updates/F11/FEDORA-2009-8708
Comment 16 Fedora Update System 2009-08-18 17:17:39 EDT
php-layers-menu-3.2.0-0.2.rc.fc10 has been pushed to the Fedora 10 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update php-layers-menu'.  You can provide feedback for this update here: http://admin.fedoraproject.org/updates/F10/FEDORA-2009-8732
Comment 17 Fedora Update System 2009-09-02 16:55:56 EDT
php-layers-menu-3.2.0-0.2.rc.el5 has been pushed to the Fedora EPEL 5 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 18 Fedora Update System 2009-09-02 20:33:08 EDT
php-layers-menu-3.2.0-0.2.rc.fc11 has been pushed to the Fedora 11 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 19 Fedora Update System 2009-09-02 20:33:25 EDT
php-layers-menu-3.2.0-0.2.rc.fc10 has been pushed to the Fedora 10 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.